UNIT BOXHUSER; {Umsetzung der UNIT BOXUSER fr HASHING}


INTERFACE
USES
     BOXVARS;

TYPE str20 = STRING[20];
     UserInfoArray = ARRAY[1..8] OF CHAR;
     str3 = STRING[3];
     str5 = STRING[5];
     str6 = STRING[6];
     str8 = STRING[8];
     str10 = STRING[10];
     str12 = STRING[12];
     str15 = STRING[15];
     str40 = STRING[40];
     str127 = STRING[127];

FUNCTION GetIt(VAR CALL:STR10;var u:R_UserFile):BOOLEAN;
FUNCTION GetLevel(Call:str6):BYTE;
PROCEDURE SetLevel(Call:str6;level:BYTE);
FUNCTION Is_Friend(Call:str6;friend:str6):BOOLEAN;
PROCEDURE AddFriend(Call:str6;friend:str6);
PROCEDURE DelFriend(Call:str6;friend:str6);
FUNCTION Set_Name(Call: str6; Name: str20): BOOLEAN;
FUNCTION Set_MYBBS(Call: str6; Rufz: str20): BOOLEAN;
PROCEDURE Set_SPK(Call: str6; Spk: str3);
PROCEDURE Set_LastMYBBS(Call: str6; time: LONGINT);
PROCEDURE GetBoxUser(ch: BYTE);
FUNCTION GetLastLogin(VAR OK: BOOLEAN; Call: str6): LONGINT;
FUNCTION GetLastQuit(VAR OK: BOOLEAN; Call: str6): LONGINT;
FUNCTION GetLastMyBBS(Call: str6): LONGINT;
FUNCTION GetName(VAR OK: BOOLEAN; ch: BYTE): STRING;
FUNCTION GetUser(VAR OK: BOOLEAN; VAR U: R_UserFile; Call: str6): BOOLEAN;
PROCEDURE AddOneLogin(Call: str6);
PROCEDURE SetLogin(ch: BYTE);
PROCEDURE AddOneSend(Call: str6);
PROCEDURE AddOneRead(Call: str6);
PROCEDURE AddOneGet(Call: str6);
FUNCTION GetMYBBS(Call: str6): str6;
PROCEDURE SetQuit(ch: BYTE);
FUNCTION GetSpk(ch: BYTE): str3;
PROCEDURE GetSetInfos(Call: str6; VAR SetInfo: BYTE);
PROCEDURE PutSetInfos(Call: str6; SetInfo: BYTE);
FUNCTION GetReadLockInfo(Call: str8): BYTE;
PROCEDURE SetReadLock(Call: STRING; ReadLock: BYTE);
FUNCTION IsPasswd(Call: str6): BOOLEAN;
FUNCTION GetPasswd(Call: str6; VAR Passwd: STRING): BOOLEAN;
PROCEDURE SetPasswd(Call: str6; Passwd: STRING);
PROCEDURE DelPasswd(Call: str6);
PROCEDURE SetPromptStr(Call: str6; PromptString: STRING);
PROCEDURE SetPromptNr(Call: str6; PromptNr: BYTE);
PROCEDURE SetHelpLevel(Call: str6; Level: BYTE);
FUNCTION GetHelpLevel(Call: str6): BYTE;

PROCEDURE InitUserFile;

IMPLEMENTATION

USES FileHash,BOXUTIL,IADVAR,DOS,TOOLBOX;


VAR
    ActUserRec:R_UserFile;

PROCEDURE Leeren(VAR U: R_UserFile);
BEGIN
  Fillchar(U,SizeOf(R_UserFile),0);
  U.Prompt := 1;
  U.Spk := 'DL';
  U.ReadList := 251;
  U.HelpLevel := 2;
END;



FUNCTION GetIt(VAR CALL:STR10;var u:R_UserFile):BOOLEAN;
VAR position : LONGINT;f:file of r_userfile;ok:BOOLEAN;S:STRING;
BEGIN
  Call := Gross(LTRIM(RTRIM(Call)));
  Call:= CutSSid(call);
  OK:=UserHash^.GetData(call,@position);
  IF (position>1000) AND OK THEN
  BEGIN
     getit:=false;
     str(position,s);
     profileBox('UserHash: Invalid filepos for :'+Call+' : '+s,PBOX_IOERROR);
     exit;
  END;   
  IF OK THEN
  BEGIN
    assign(f,BOXPATH+'usrdat');
    reset(f);
    IF IOresult<>0 THEN
    BEGIN
      GetIt:=FALSE;
      exit;
    END;
    seek(f,position);
    IF IORESULT>0 THEN
    BEGIN
      ProfileBOX('IOFail: BOXHUSER SEEK M_FILE',PBOX_IOERROR);
      GetIt:=FALSE;
      exit;
    END;
    read(f,u);
    IF IORESULT>0 THEN
    BEGIN
      ProfileBOX('IOFail: BOXHUSER READ M_FILE',PBOX_IOERROR);
      GetIt:=FALSE;
      exit;
    END;
    close(f);
    IF IORESULT>0 THEN
    BEGIN
      ProfileBOX('IOFail: BOXHUSER CLOSE M_FILE',PBOX_IOERROR);
      GetIt:=FALSE;
      exit;
    END;

    getit:=TRUE
  END ELSE GETIT:=FALSE;
END;

FUNCTION PutIt(CALL:STRING10;var u:R_UserFile):BOOLEAN;
VAR position : LONGINT;f:file of r_userfile;ok:BOOLEAN;S:STRING;
BEGIN
  Call := Gross(LTRIM(RTRIM(Call)));
  OK:=UserHash^.GetData(call,@position);
  IF (position > 1000) AND OK THEN
  BEGIN
     putit:=false;
     str(position,s);
     profileBox('UserHash: Invalid filepos for :'+Call+' : '+s,PBOX_IOERROR);
     exit;
  END;   
  
  IF OK THEN
  BEGIN
    assign(f,BOXPATH+'usrdat');
    reset(f);
    IF IOresult<>0 THEN
    BEGIN
      Putit:=FALSE;
      exit;
    END;
    seek(f,position);
    IF IORESULT>0 THEN
    BEGIN
      ProfileBOX('IOFail: BOXHUSER SEEK USRFILE',PBOX_IOERROR);
      PutIt:=FALSE;
      exit;
    END;
    Write(f,u);
    IF IORESULT>0 THEN
    BEGIN
      ProfileBOX('IOFail: BOXHUSER SEEK USRFILE',PBOX_IOERROR);
      PutIt:=FALSE;
      exit;
    END;
    close(f);
    IF IORESULT>0 THEN
    BEGIN
      ProfileBOX('IOFail: BOXHUSER SEEK USRFILE',PBOX_IOERROR);
      PutIt:=FALSE;
      exit;
    END;
  END ELSE
  BEGIN
    assign(f,BOXPATH+'usrdat');
    reset(f);
    IF IOresult<>0 THEN
    BEGIN
      Rewrite(f);
      IF IOresult<>0 THEN
      BEGIN
        Putit:=FALSE;
        exit;
      END;
    END;
    position:=filesize(f);
    seek(f,position);
    IF IORESULT>0 THEN
    BEGIN
      ProfileBOX('IOFail: BOXHUSER SEEK USRFILE',PBOX_IOERROR);
      PutIt:=FALSE;
      exit;
    END;
    Write(f,u);
    IF IORESULT>0 THEN
    BEGIN
      ProfileBOX('IOFail: BOXHUSER WRITE USRFILE',PBOX_IOERROR);
      PutIt:=FALSE;
      exit;
    END;
    close(f);
    IF IORESULT>0 THEN
    BEGIN
      ProfileBOX('IOFail: BOXHUSER CLOSE USRFILE',PBOX_IOERROR);
      PutIt:=FALSE;
      exit;
    END;
    UserHash^.InsertData(call,position);
  END;
  PutIT:=TRUE;
END;


PROCEDURE InitUserFile;
var position:LONGINT;s:string;
    f:FILE OF r_userfile;  newuserfile:BOOLEAN;
BEGIN
  {$I-}
  newuserfile:=FALSE;
  assign(f,BOXPATH+'usrdat');
  reset(f);
  IF IOresult<>0 THEN
  BEGIN
    WriteLn('User-Daten-File existiert nicht...');
    Rewrite(f);
    IF IORESULT <> 0 THEN
    BEGIN
       WriteLn('...und kann nicht erstellt werden');
       EXIT;
    END ELSE
      WriteLn('... wird angelegt');
    move(userfileversion[0],actuserrec,9);
    write(f,actuserrec);
    newuserfile:=true;
    close(f);
    reset(f);
  END;
  READ(f,actuserrec);
  move(actuserrec,s[0],9);
  IF (s<>userfileversion) OR (IOResult<>0) THEN
  BEGIN
    close(f);
    WriteLn('Userdatenfile veraltet....');
    rename(f,boxpath+'OLDUSR');
    IF ioresult<>0 THEN;
    assign(f,boxpath+'usrdat');
    Rewrite(f);
    move(userfileversion[0],actuserrec,9);
    write(f,actuserrec);
    newuserfile:=TRUE;
    IF IOresult<>0 THEN exit;
  END;
  close(f);
  UserHash:=New(PFHash,init(boxpath+'userhash'));
  IF (HashError>0) or (newUserfile) THEN
  BEGIN
    WriteLn('Creating User-IndexFile');
    UserHash:=New(PFHash,create(boxpath+'userhash',9973,4));
    IF HashError>0 THEN
    BEGIN
      WriteLn('Can'#39't create UserHash');
      halt;
    END;
    {$I-}
    assign(f,BOXPATH+'usrdat');
    reset(f);
    position:=0;
    WHILE  not eof(f) DO
    BEGIN
      Read(f,actuserrec);
      UserHash^.InsertData(actuserrec.call,position);
      inc(position);
    END;
    close(f);
  END;
END;


{Namen setzen - TRUE:  FileVersion OK
                FALSE: FileVersion nicht OK }
FUNCTION Set_Name(Call: str6; Name: str20): BOOLEAN;
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,ActUserRec);
  IF DoesExist THEN
  BEGIN
    ActUserRec.Name:=Name;
  END ELSE
  BEGIN
    Leeren(actUserRec);
    ActUserRec.Call:=call;
    ActUserRec.Name:=name;
  END;
  Set_Name:=PutIt(call,ActUserRec);
END;

FUNCTION Set_MYBBS(Call: str6; Rufz: str20): BOOLEAN;
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,ActUserRec);;
  IF DoesExist THEN
  BEGIN
    ActUserRec.MyBBS:=Rufz;
  END ELSE
  BEGIN
    Leeren(actUserRec);
    ActUserRec.Call:=call;
    ActUserRec.mybbs:=rufz;
  END;
  Set_MYBBS:=PutIt(call,ActUserRec);
END;

PROCEDURE Set_LastMYBBS(Call: str6; time: LONGINT);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    ActUserRec.LastMybbs:=time;
  END ELSE
  BEGIN
    Leeren(actUserRec);
    ActUserRec.Call:=call;
    ActUserRec.LastMybbs:=time;
  END;
  PutIt(call,ActUserRec);
END;

PROCEDURE Set_SPK(Call: str6; Spk: str3);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    ActUserRec.spk:=spk;
  END ELSE
  BEGIN
    Leeren(actUserRec);
    ActUserRec.Call:=call;
    ActUserRec.spk:=spk;
  END;
  PutIt(call,ActUserRec);
END;

FUNCTION Is_Friend(Call:str6;friend:str6):BOOLEAN;
BEGIN
  IF GetIt(call,actuserrec) THEN
  BEGIN
    Is_Friend:=(POS(friend+' ',actuserrec.friends)>0);
  END ELSE
    Is_Friend:=False;
END;
PROCEDURE AddFriend(Call:str6;friend:str6);

BEGIN
  IF GetIt(call,actuserrec) THEN
  BEGIN
    IF (actuserrec.friends[0]>#60) OR (actuserrec.friends[0]=#0) THEN
      actuserrec.friends:='~';
    IF actuserrec.friends[1]<>'~' THEN
       actuserrec.friends:='~';
    IF (POS(friend+' ',actuserrec.friends)=0) THEN
    actuserrec.friends:=actuserrec.friends+friend+' ';
  END ELSE
  BEGIN
    Leeren(actUserRec);
    ActUserRec.call:=call;
    ActUserRec.friends:='~'+friend+' ';
  END;
  PutIt(call,ActUserRec);
END;
PROCEDURE DelFriend(Call:str6;friend:str6);

BEGIN
  IF GetIt(call,actuserrec) THEN
  BEGIN
    IF (POS(friend+' ',actuserrec.friends)>0) THEN
      Delete(actuserrec.friends,POS(friend+' ',actuserrec.friends),length(friend)+1);
    PutIt(call,ActUserRec);
  END
END;

PROCEDURE GetBoxUser(ch: BYTE);
VAR
    DoesExist: BOOLEAN;
    Call:STRING12;

BEGIN
  CALL:=KS[ch]^.Call;
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    KS[ch]^.BoxData^.Prompt := ActUserRec.Prompt;
    KS[ch]^.BoxData^.HelpLevel := ActUserRec.HelpLevel;
      IF ActUserRec.Prompt=255 THEN BEGIN
        NEW(KS[ch]^.BoxData^.Prompt_Str);
        KS[ch]^.BoxData^.Prompt_Str^ := ActUserRec.PromptStr;
      END;
    KS[ch]^.BoxData^.MYBBS := ActUserRec.MYBBS;
  END ELSE
  BEGIN
    KS[ch]^.BoxData^.Prompt := 1;
    KS[ch]^.BoxData^.Prompt_Str := NIL;
    KS[ch]^.BoxData^.MYBBS := '';
    KS[ch]^.BoxData^.HelpLevel := 2;
  END;
END;

{LastLogin-Datum von Call 'raus suchen}
FUNCTION GetLastLogin(VAR OK: BOOLEAN; Call: str6): LONGINT;
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  OK:=TRUE;
  IF DoesExist THEN
    GetLastLogin:=ActUserRec.LastLogin
  ELSE
    GetLastLogin:=0;
END;

FUNCTION GetLastMyBBS(Call: str6): LONGINT;
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
    GetLastMyBBS:=ActUserRec.LastMyBBS
  ELSE
    GetLastMyBBS:=0;
END;

{Lastquit-Datum und Zeit von Call 'raus suchen}
FUNCTION GetLastQuit(VAR OK: BOOLEAN; Call: str6): LONGINT;
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  OK:=TRUE;
  IF DoesExist THEN
    GetLastQuit:=ActUserRec.LastQuit
  ELSE
    GetLastQuit:=0;
END;

FUNCTION GetName(VAR OK: BOOLEAN; ch: BYTE): STRING;
VAR DoesExist:BOOLEAN;
    Call:STRING12;
BEGIN
  Call := KS[ch]^.Call;
  DoesExist:=GetIt(call,actuserrec);
  OK:=TRUE;
  IF DoesExist THEN
    GetName:=ActUserRec.Name
  ELSE
    GetName:='';
END;


FUNCTION GetMYBBS(Call: str6): str6;
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
    GetMyBBS:=ActUserRec.MyBBS
  ELSE
    GetMyBBS:='';
END;


FUNCTION GetUser(VAR OK: BOOLEAN; VAR U: R_UserFile; Call: str6): BOOLEAN;
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  OK:=TRUE;
  IF DoesExist THEN
    U:=ActUserRec
  ELSE
  BEGIN
    U.call:=call;
    Leeren(U);
  END;
  GetUser:=DoesExist;
END;

PROCEDURE AddOneLogin(Call: str6);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    INC(ActUserRec.Anz_Logins);
  END ELSE
  BEGIN
    Leeren(ActUserRec);
    ActUserRec.Call:=call;
    ActUserRec.Anz_Logins:=1;
  END;
  PutIt(call,ActUserRec);
END;

PROCEDURE AddOneSend(Call: str6);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    INC(ActUserRec.Anz_Send);
  END ELSE
  BEGIN
    Leeren(ActUserRec);
    ActUserRec.Call:=call;
    ActUserRec.Anz_Send:=1;
  END;
  PutIt(call,ActUserRec);
END;

PROCEDURE AddOneRead(Call: str6);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    INC(ActUserRec.Anz_Read);
  END ELSE
  BEGIN
    Leeren(ActUserRec);
    ActUserRec.Call:=call;
    ActUserRec.Anz_Read:=1;
  END;
  PutIt(call,ActUserRec);
END;

PROCEDURE AddOneGet(Call: str6);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    INC(ActUserRec.Anz_Rec);
  END ELSE
  BEGIN
    Leeren(ActUserRec);
    ActUserRec.Call:=call;
    ActUserRec.Anz_Rec:=1;
  END;
  PutIt(call,ActUserRec);
END;

PROCEDURE SetLogin(ch: BYTE);
VAR DoesExist:BOOLEAN;
    Call:STRING12;
    jetzt: LONGINT;
    DT: DateTime;
    muell: WORD;
BEGIN
  Call := KS[ch]^.Call;
  Jetzt:=Unix2Pack(CurrIxTime);
  DoesExist:=GetIt(call,actuserrec);
  ActUserRec.LastLogin:=Jetzt;
  If NOT DoesExist THEN
  BEGIN
    Leeren(ActUserRec);
    ActUserRec.Call:=call;
  END;
  PutIt(call,ActUserRec);
END;

PROCEDURE SetQuit(ch: BYTE);
VAR DoesExist:BOOLEAN;
    Call:STRING12;
    jetzt: LONGINT;
    DT: DateTime;
    muell: WORD;
BEGIN
  Call := KS[ch]^.Call;
  Jetzt:=Unix2Pack(CurrIxTime);
  DoesExist:=GetIt(call,actuserrec);
  ActUserRec.LastQuit:=Jetzt;
  IF NOT DoesExist THEN
  BEGIN
    Leeren(ActUserRec);
    ActUserRec.Call:=call;
  END;
  PutIt(call,ActUserRec);
END;

FUNCTION StandardSpk(ch: BYTE): str3;
VAR f: Text;
    S: STRING;
    Spk: STRING[3];
    Call: STRING[6];
    Hlp: STRING;
BEGIN
  ASSIGN(f,BoxPath+'LANGUAGE');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    StandardSpk := 'DL';
    Exit;
  END;

  Spk := '';
  Call := CutSSID(KS[ch]^.Call);
  WHILE NOT EOF(f) DO BEGIN
    READLN(f,S);
    IF S[1] = '*' THEN Spk := LTRIM(RTRIM(COPY(S,2,255)))
    ELSE BEGIN
      Hlp := LTRIM(RTRIM(COPY(S,1,POS(' ',S)-1)));
      S := LTRIM(RTRIM(COPY(S,POS(' ',S)+1,255)));
      IF Hlp = COPY(Call,1,LENGTH(Hlp)) THEN Spk := S;
    END;
  END;
  IF Spk = '' THEN Spk := 'DL';
  CLOSE(f);
  StandardSpk := Spk;
END;

FUNCTION GetSpk(ch: BYTE): str3;
VAR DoesExist:BOOLEAN;
    Call:STRING12;
BEGIN
  Call := KS[ch]^.Call;
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
    GetSpk:=ActUserRec.Spk
  ELSE
    GetSpk:=StandardSpk(ch);
END;

PROCEDURE GetSetInfos(Call: str6; VAR SetInfo: BYTE);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN SetInfo := ActUserRec.ReadList
               ELSE SetInfo := $FF;
END;

PROCEDURE PutSetInfos(Call: str6; SetInfo: BYTE);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN ActUserRec.ReadList:=SetInfo
  ELSE BEGIN
    Leeren(ActUserRec);
    ActUserRec.Call:=call;
    ActuserRec.Readlist:=SetInfo;
  END;
  PutIt(call,ActUserRec);
END;

FUNCTION GetReadLockInfo(Call: str8): BYTE;
VAR DoesExist:BOOLEAN;
BEGIN
  {$R-}
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
    GetReadLockInfo:=ActUserRec.ReadLock
  ELSE
    GetReadLockInfo:=0;
  {$R+}
END;

PROCEDURE SetReadLock(Call: STRING; ReadLock: BYTE);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    ActUserRec.Readlock:=ReadLock;
  END ELSE
  BEGIN
    Leeren(actUserRec);
    ActUserRec.Call:=call;
    ActUserRec.ReadLock:=ReadLock;
  END;
  PutIt(call,ActUserRec);
END;

{Password aus PASSWD.BOX auslesen
 Rckgabe: TRUE, wenn ein Passwort gesetzt ist, sonst FALSE}
FUNCTION IsPasswd(Call: str6): BOOLEAN;
VAR   DoesExist:BOOLEAN;
BEGIN

  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
    IsPassWd:=ActUserRec.UserPassWord<>''
  ELSE
    IsPassWd:=FALSE;
END;


{Password aus PASSWD.BOX auslesen
 Rckgabe: TRUE, wenn ein Passwort gesetzt ist, sonst FALSE}
FUNCTION GetPasswd(Call: str6; VAR Passwd: STRING): BOOLEAN;
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    GetPassWd:=ActUserRec.UserPassWord<>'';
    PassWd:=ActUserRec.UserPassWord;
  END
  ELSE
    GetPassWd:=FALSE;
END;


{Passwort setzen}
PROCEDURE SetPasswd(Call: str6; Passwd: STRING);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
    ActUserRec.UserPassWord:=passwd
  ELSE
  BEGIN
    Leeren(actuserrec);
    ActUserRec.UserPassWord:=passwd;
  END;
  PutIt(call,ActUserRec);
END;


{Lscht das Passwort von Call}
PROCEDURE DelPasswd(Call: str6);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
    ActUserRec.UserPassWord:=''
  ELSE
    Leeren(actuserrec);
  PutIt(call,ActUserRec);
END;

PROCEDURE SetPromptStr(Call: str6; PromptString: STRING);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
    ActUserRec.PromptStr:=PromptString
  ELSE
  BEGIN
    Leeren(actUserRec);
    ActUserRec.Call:=call;
    ActUserRec.PromptStr:=PromptString;
  END;
  PutIt(call,ActUserRec);
END;

PROCEDURE SetPromptNr(Call: str6; PromptNr: BYTE);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    ActUserRec.Prompt:=PromptNr;
  END ELSE
  BEGIN
    Leeren(actUserRec);
    ActUserRec.Call:=call;
    ActUserRec.Prompt:=PromptNr;
  END;
  PutIt(call,ActUserRec);
END;

PROCEDURE SetHelpLevel(Call: str6; Level: BYTE);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    ActUserRec.HelpLevel:=Level;
  END ELSE
  BEGIN
    Leeren(actUserRec);
    ActUserRec.Call:=call;
    ActUserRec.HelpLevel:=Level;
  END;
  PutIt(call,ActUserRec);
END;

FUNCTION GetHelpLevel(Call: str6): BYTE;
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
    GetHelpLevel:=ActUserRec.HelpLevel
  ELSE
    GetHelpLevel:=2;
END;

FUNCTION GetLevel(Call:str6):BYTE;
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
    GetLevel:=ActUserRec.Level
  ELSE
    GetLevel:=2;
END;


PROCEDURE SetLevel(Call:str6;level:BYTE);
VAR DoesExist:BOOLEAN;
BEGIN
  DoesExist:=GetIt(call,actuserrec);
  IF DoesExist THEN
  BEGIN
    ActUserRec.Level:=Level;
  END ELSE
  BEGIN
    Leeren(actUserRec);
    ActUserRec.Call:=call;
    ActUserRec.Level:=Level;
  END;
  PutIt(call,ActUserRec);
END;


END.