UNIT MH;

INTERFACE

  PROCEDURE MHHandleKey;
  PROCEDURE MHReDraw;
  PROCEDURE MHInit;

IMPLEMENTATION

USES IADVAR,KEYMAKRO,PACKET,SCREEN,TOOLBOX,VIDEO,CRT;
CONST act:BYTE=1;
      LastConsoleState:BYTE=CONS_TERM;
      start:BYTE=1;

PROCEDURE MHHandleKey;
BEGIN
  CASE XREADKEY OF
    #27:BEGIN
          consolestate:=lastconsolestate;
          redrawscreen;
          exit;
        END;  
    #0:CASE XREADKEY OF
      KEY_UP:BEGIN
               IF act>1 THEN dec(act);
               IF start<act THEN start:=act;
               MHRedraw;
             END;
      KEY_DOWN:
            BEGIN
              IF act<255 THEN inc(act);
              IF act>(start+_zeilen-1) THEN
                 start:=(act-_zeilen+1);
              MHRedraw;
            END;
      KEY_PGUP:BEGIN END;
      KEY_PGDN:BEGIN END;
    END;
  END;  
END;  

PROCEDURE MHReDraw;
VAR B,zeile,farbe:BYTE;s:string;
BEGIN
 Writeln(#7);
 zeile:=2;b:=start;
 WHILE (zeile<=_zeilen) AND (b<255) DO BEGIN
  str(b,s);
  IF mhliste[b]<>NIL THEN
  BEGIN
    inc(zeile);
    if b=act then
         farbe:=fDLgaktiv else farbe:=fDLGinaktiv;
    prints(1,zeile,s+':'+mhliste[b]^.src,farbe);
  END ELSE prints(1,Zeile,s+':NIL',farbe);
  inc(b);
 END; 
 UpdateScreen;
END;

PROCEDURE MHInit;
BEGIN
 act:=1;
 start:=1;
 LastConsoleState:=ConsoleState;
 ConsoleState:=CONS_MH;
 MHReDraw;
END;

END.
