PROGRAM Txt2Message;

CONST
  Version = '1.0';
  Datum = '05.03.95';


PROCEDURE Info;
BEGIN
  WRITELN('TXT2MSG V'+Version+' ('+Datum+')');
  WRITELN('by Jochen Sarrazin');
END;



PROCEDURE Wandel;
TYPE str80 = STRING[80];
VAR f: Text;
    F_S80: FILE OF str80;
    S80: str80;
BEGIN
  ASSIGN(f,ParamStr(1));
  { $I-}
  RESET(f);
  { $I+}
  IF IOResult <> 0 THEN BEGIN
    Info;
    WRITELN;
    WRITELN(ParamStr(1)+' ist nicht vorhanden!');
  END;
  ASSIGN(F_S80,'MESSAGES.'+ParamStr(2));
  REWRITE(F_S80);

  Info;
  WRITELN;

  WHILE NOT EOF(f) DO BEGIN
    READLN(f,S80);
    WRITE(F_S80,S80);
    WRITE('.');
  END;
  CLOSE(f);
  CLOSE(F_S80);
  WRITELN; WRITELN;
END;


BEGIN
  IF ParamCount < 2 THEN BEGIN
    Info;
    WRITELN;
    WRITELN('Syntax: TXT2MSG <Klartext-File> <Abkrzung>');
    WRITELN;
    WRITELN('also z.B.:  TXT2MSG deutsch.txt DL');
    WRITELN; WRITELN;
    Halt;
  END;

  IF LENGTH(ParamStr(2)) > 3 THEN BEGIN
    Info;
    WRITELN;
    WRITELN('Die Abkrzung der Sprache darf nicht lnger als 3 Zeichen sein!');
    WRITELN; WRITELN;
    Halt;
  END;

  Wandel;

END.
