(* ein weiterer ansatz fuer einen spy *)
UNIT SPYNEW;                                                 

INTERFACE
TYPE STRING10=STRING[10];

PROCEDURE SpyHandleKey;
PROCEDURE HandleSpy(ans,anr:BYTE;VAR asrc,adst:STRING;var data1;len:word);
PROCEDURE SpyRedraw;
PROCEDURE StartSpyMode;
PROCEDURE InitSpy(asrc,adst:STRING10);
PROCEDURE delspy(spynr:BYTE);

IMPLEMENTATION
USES MCUTBUF,IADVAR,KEYMAKRO,SCREEN,PACKET,TOOLBOX,VIDEO,WGTCRC;

TYPE 
  PFrameRec=^FrameRec;
  FRAMEREC=RECORD
    data:Array[0..255] of CHAR;
    len:word;
  END;  
  SPYREC=RECORD
    nr,ns:BYTE;
    src,dst:STRING[10];
    crcs,crcr:ARRAY[0..7] OF WORD;
    samr,sams:ARRAY[0..7] OF pFrameRec;
    buf:PMBuf; 
  END;
  PSPY=^SPYREC;
  tbyte=ARRAY[1..1024] OF BYTE;

CONST MAXSPY=10;
      spybufsize=10;
      LastConsoleState:BYTE=0;
VAR SPYS:ARRAY[1..MAXSPY] OF PSPY;

PROCEDURE SpyRedraw;
VAR DATA:STRING;
BEGIN
  IF SPYs[current_spy]=NIL THEN exit;
  SPYs[current_spy]^.buf^.showbuf;
  WITH Spys[current_spy]^ DO
  BEGIN
        {str(ans,data);prints(20,1,'ans:'+data,112);}
        prints(10,1,src+' '+dst,112);
        str(ns,data);prints(40,1,'ns:'+data,112);
        str(nr,data);prints(50,1,'nr:'+data,112);
  
  END;
END;
  
PROCEDURE InitSpy(asrc,adst:STRING10);
VAR B:BYTE;hash:integer;P:Pmhentry;direct:BOOLEAN;
BEGIN
  B:=1;
  WHILE (SPYS[B]<>NIL) AND (b<11) DO INC(B);
  IF b=11 THEN
  BEGIN
    WriteLn(#7);
    exit;
  END;
  p:=findmhentry(asrc,adst);
  IF P=NIL THEN exit ELSE
  BEGIN
    IF p^.spynr=0 THEN
        p^.spynr:=b 
    ELSE
    BEGIN
      PopUP('already spying '+asrc);
      exit;
    END;
  END;        
  new(Spys[b]);
  WITH spys[b]^ DO
  BEGIN
    src:=asrc;dst:=adst;
    ns:=8;nr:=8;
    buf:=new(PMBuf,init(spybufsize,fqsotx,fqsorx,pqsowin,pqsowin+qsowinsize,BufSwapTypes)); 
  END;
  current_spy:=b;
END;

PROCEDURE DelSpy(spynr:BYTE);
VAR B:BYTE;
BEGIN
 IF Spys[spynr]=NIL THEN exit;
 IF spys[spynr]^.buf<>NIL then dispose(spys[spynr]^.buf,done);
 FOR B:=0 TO 7 DO
   IF spys[spynr]^.samr[b]<>NIL then DISPOSE(spys[spynr]^.samr[b]);
 FOR B:=0 TO 7 DO
   IF spys[spynr]^.sams[b]<>NIL then DISPOSE(spys[spynr]^.sams[b]);
 DISPOSE(Spys[b]);
 Spys[b]:=NIL;
END;
   
(*
     TMHEntry=RECORD
        src,dest:STRING[10];
        path:string;
        port:byte; 
        tkby,rkby,text,tcpip,netrom,flexnet,pacsat:WORD;
        RR,REJ,I,PLUS,MINUS,frames,tottxd:LONGINT;
        lasttxd,avgtxd,maxtxd:BYTE;
        spynr:byte;
        last:longint;
     END;   
  *)
PROCEDURE HandleSpy(ans,anr:BYTE;VAR asrc,adst:STRING;var data1;len:word);
VAR B:BYTE;farbe:BYTE;data:STRING;hash:integer;P:PMHEntry;direct:BOOLEAN;
  tim,stim,bits,hundsecs:LONGINT;
BEGIN
{$IFDEF BB}
  inc(bbentrypos);
  if bbentrypos=101 THEN bbentrypos:=0;
  with bbarr[bbentrypos] do
  BEGIN
    tim:=currixtime;
    call:=head.fmc;
    stoptime:=tim;
    bits:=(((head.len+length(head.fmc)+length(head.toc)+10)*8));
    hundsecs:=round(bits*(100/1200))+(head.txd);
    stim:=round(exacttime-hundsecs);
    starttime:=stoptime-(hundsecs DIV  100);
    starth:=(exacttime-hundsecs) mod 100;
    stoph:=exacttime mod 100;
    if starth>stoph then dec(starttime);
    txd:=head.txd;
  END;  
{$ENDIF}
  WITH Head DO 
  BEGIN
    P:=insertMHEntry(fmc,toc);
    if P<>NIL THEN
    BEGIN
      WITH P^ DO
      BEGIN
	
         src:=fmc;
         IF pos(' ',toc)>0 THEN
           dest:=copy(toc,1,pos(' ',toc)-1) ELSE
           dest:=toc;
         inc(tkby,len);
         port:=head.port;
         case head.typ of
           Fr_I:inc(I);
           Fr_RR:inc(RR);
           Fr_REJ:inc(REJ);
	 END; { case }
	 if head.txd<>0 THEN
	 BEGIN   
	   lasttxd:=head.txd;
	    if head.txd>maxtxd then maxtxd:=head.txd;
	    avgtxd:=round(((longint(avgtxd)*tottxd)+lasttxd) /( tottxd+1));
	    inc(tottxd);
	 END;
	 IF head.typ IN [Fr_I,Fr_UI] THEN
         BEGIN
           case head.pid of
             $CC,$08:inc(tcpip);
             $F0:inc(text);
             $CF:inc(netrom);
             $CE:inc(flexnet);
             $B0:inc(pacsat);
           ELSE inc(unknown)
           END;   
         END;
         last:=currixtime;
      END;
    END;       
  END;       
  b:=p^.spynr;
  if len=0 THEN exit;
  if B>0 THEN BEGIN
     IF (SPYS[b]<>NIL) THEN
      IF ((Spys[b]^.src=asrc) AND (Spys[b]^.dst=adst)) OR
         ((Spys[b]^.src=adst) AND (Spys[b]^.dst=asrc)) THEN
      WITH SPYS[b]^ DO
      BEGIN
        direct:=src=asrc;
        prints(1,1,asrc+' '+adst,112);
        str(ans,data);prints(20,1,'ans:'+data,112);
        str(anr,data);prints(30,1,'anr:'+data,112);
        str(ns,data);prints(40,1,'ns:'+data,112);
        str(nr,data);prints(50,1,'nr:'+data,112);
        
        if direct THEN farbe:=fqsotx else farbe:=fqsorx;
        IF (ns=8) THEN ns:=ans;
        IF (nr=8) THEN nr:=anr;
        IF ((ns=ans) and (src=asrc)) OR ((nr=anr) and (src=adst)) THEN
        BEGIN
           if direct THEN crcs[ns]:=BuildBufferCRC(data1,len,0)
              ELSE crcr[nr]:=BuildBufferCRC(data1,len,0);
           IF len<256 THEN
           BEGIN 
             move(data1,data[1],len);
             data[0]:=char(len);
             prints(1,1,'b',112);
             if buf=NIL THEN prints(1,1,'c',112);
             buf^.WriteBuf(data,farbe);
           END ELSE
           BEGIN
             move(data1,data[1],255);
             data[0]:=#255;
             buf^.WriteBuf(data,farbe);
             {move(ptr(seg(data1),ofs(data1)+256)^,data[1],len-255);
             data[0]:=char(len-255); 
             Buf^.WriteBuf(data,farbe);}  
           END;  
        END
        ELSE 
        BEGIN
          IF (direct AND (crcs[ans]=BuildBufferCRC(data1,len,0))) OR
             (not direct AND (crcr[anr]=BuildBufferCRC(data1,len,0))) THEN
          BEGIN
          END ELSE
          BEGIN   
            if direct THEN ns:=ans else nr:=anr;
            buf^.WriteBuf('*** Frame lost'+#13,farbe);
          END;
         END;
        buf^.showbuf;
        if direct THEN
        BEGIN
            inc(ns);if ns=8 THEN ns:=0
        END ELSE
        BEGIN
           inc(nr);if nr=8 THEN nr:=0;
        END;
      END;
           
     END;   
END;                                                         

PROCEDURE SpyHandleKey;
VAR taste:CHAR;
BEGIN
  (*
   * Tastaturcode einlesen, via KEYMACRO.PAS
   *)
  taste:=Xreadkey;
  CASE taste OF
    (*
     * ESC und CR kehren auf den zuletzt benutzten Kanal
     * zurck.
     *)
    #27,#13:BEGIN
          ConsoleState:=LastConsoleState;
          (* Spys[current_spy]^.buf^.Resize(pmoni,pmoni+moniwinsize);*)
          Redrawscreen;
        END;
    (*
     * Save-File ffnen
     *)
    'S':BEGIN
          (* MoniSaveDlg; *)
        END;
    (*
     * Einstellungen
     *)
    'O':BEGIN
          (* MoniSettingsDlg *)
        END;
    (*
     * Sondertasten
     *)
    #0:BEGIN
        taste:=Xreadkey;
        CASE taste OF
         (* Scrollen *)
         #80:{pfeil unten}
               Spys[current_spy]^.buf^.PageDown(1);
         #72:{pfeil oben}
               Spys[current_spy]^.buf^.PageUp(1);
         #73:{pgup}
             IF ScreenWriteOk THEN
                 Spys[current_spy]^.buf^.PageUp(bigmoniwinsize);
         #81:{pgDn}
             IF ScreenWriteOk THEN
                 Spys[current_spy]^.buf^.PageDown(bigmoniwinsize);
         #59..#68:{F1-F10}
                Begin
                 IF (byte(taste)-58) <= MAXSPY THEN
                   current_spy:=byte(taste)-58;
                   Redrawscreen;
                END;

       END;
    END;
  END;
END;

PROCEDURE StartSpyMode;
BEGIN
  LastConsoleState:=ConsoleState;
  ConsoleState:=CONS_SPY;
  RedrawScreen;
END;
  
BEGIN
  fillchar(spys,10*SizeOf(Pointer),0);
END.










